<meta charset="utf-8">
<head>
    <script src="https://d3js.org/d3.v7.min.js"></script>
</head>

<body>
    <h1>Test SVG image timeline and zooming on SVG element</h1>
    <form>
        <button name="in" type="button" onclick="zoomIn()">Zoom In</button>
        <button name="out" type="button" onclick="zoomOut()">Zoom Out</button>
    </form>
    <div class="viewer-container" id="viewer-container"></div>
</body>

<script>
    height = 600;
    width = 1400;
    bmargin = 40

    figheight = 256;

    container_div = d3.select(".viewer-container")

    var svg =container_div
        .append('svg')
        .attr("width", width)
        .attr("height", height + bmargin)
        .attr("viewBox", [0, 0, width, height + bmargin]);

    // Add axes
    var xscale = d3.scaleTime()
        .domain([new Date("2021-12-01T00:00:00Z"), new Date("2021-12-25T00:00:00Z")])
        .range([0, width]);

    xAxis = d3.axisBottom(xscale);

    gxaxis = svg.append("g")
        .attr("transform", "translate(0, " + (height) + ")")
        .call(xAxis);

    // Add image
    images = [
        {url: "https://sdo.gsfc.nasa.gov/assets/img/browse/2021/12/09/20211209_000000_512_HMIB.jpg", starttime: new Date("2021-12-09T00:00:00"), endtime: new Date("2021-12-10T00:00:00")},
        {url: "https://sdo.gsfc.nasa.gov/assets/img/browse/2021/12/10/20211210_000000_512_HMIB.jpg", starttime: new Date("2021-12-10T00:00:00"), endtime: new Date("2021-12-11T00:00:00")},
        {url: "https://sdo.gsfc.nasa.gov/assets/img/browse/2021/12/11/20211211_000000_512_HMIB.jpg", starttime: new Date("2021-12-11T00:00:00"), endtime: new Date("2021-12-12T00:00:00")},
        {url: "https://sdo.gsfc.nasa.gov/assets/img/browse/2021/12/12/20211212_000000_512_HMIB.jpg", starttime: new Date("2021-12-12T00:00:00"), endtime: new Date("2021-12-13T00:00:00")},
        {url: "https://sdo.gsfc.nasa.gov/assets/img/browse/2021/12/13/20211213_000000_512_HMIB.jpg", starttime: new Date("2021-12-13T00:00:00"), endtime: new Date("2021-12-14T00:00:00")},
        {url: "https://sdo.gsfc.nasa.gov/assets/img/browse/2021/12/14/20211214_000000_512_HMIB.jpg", starttime: new Date("2021-12-14T00:00:00"), endtime: new Date("2021-12-15T00:00:00")},
        {url: "https://sdo.gsfc.nasa.gov/assets/img/browse/2021/12/15/20211215_000000_512_HMIB.jpg", starttime: new Date("2021-12-15T00:00:00"), endtime: new Date("2021-12-16T00:00:00")},
        {url: "https://sdo.gsfc.nasa.gov/assets/img/browse/2021/12/16/20211216_000000_512_HMIB.jpg", starttime: new Date("2021-12-16T00:00:00"), endtime: new Date("2021-12-17T00:00:00")},
        {url: "https://sdo.gsfc.nasa.gov/assets/img/browse/2021/12/17/20211217_000000_512_HMIB.jpg", starttime: new Date("2021-12-17T00:00:00"), endtime: new Date("2021-12-18T00:00:00")},
        {url: "https://sdo.gsfc.nasa.gov/assets/img/browse/2021/12/18/20211218_000000_512_HMIB.jpg", starttime: new Date("2021-12-18T00:00:00"), endtime: new Date("2021-12-19T00:00:00")},
        {url: "https://sdo.gsfc.nasa.gov/assets/img/browse/2021/12/19/20211219_000000_512_HMIB.jpg", starttime: new Date("2021-12-19T00:00:00"), endtime: new Date("2021-12-20T00:00:00")}
    ]
    imagegroups = []
    imagegroups[0] = svg.append("g").attr("class", "first").attr("transform", "translate(0,300)");
    imagegroups[1] = svg.append("g").attr("class", "second").attr("transform", "translate(0,0)");

    draw_images = function() {
        imagegroups.forEach(function(imagegroup, i) {
            imagegroup.selectAll('.image').data(images)
            .enter()
                .append("image")
                .attr("xlink:href", function(d) {return d['url'];})
                .attr("preserveAspectRatio", function(d) { return imagegroup.attr("class")=="first" ? 'none' : 'xMinyMin meet' })
                .attr("x", function(d) {return xscale(d['starttime']);} )
                .attr("y", 0)
                .attr("width", function(d) { return imagegroup.attr("class")=="first" ? (xscale(d['endtime']) - xscale(d['starttime'])) : figheight; })
                .attr("height", figheight)
        })
    }
    draw_images();

    update_images = function(transform) {
        var newscale = transform.rescaleX(xscale);
        imagegroups.forEach(function(imagegroup, i) {
            imagegroup.selectAll('image')
                .attr("x", function(d) {
                    return newscale(d['starttime']);
                } )
                .attr("x", function(d) {return newscale(d['starttime']);} )
                .attr("y", 0)
                .attr("width", function(d) { return imagegroup.attr("class")=="first" ? (newscale(d['endtime']) - newscale(d['starttime'])) : figheight; })
                .attr("height", figheight)
        });
    }

    // function to call when pressing zoom buttons
    const zoom = d3.zoom()
      .extent([[0, 0], [width, height]])
      .scaleExtent([0.1, 160])
      .on("zoom", zoomed);

    // Allow zooming by mouse/trackpad
    svg.call(zoom);

    // function mousedowned(event, [,, i]) {
    // d3.select(this).transition()
    //     .attr("fill", "black")
    //     .attr("r", radius * 2)
    //   .transition()
    //     .attr("fill", d3.interpolateRainbow(i / 360))
    //     .attr("r", radius);
    // }

    function zoomed({transform}) {
        axis_transform = transform.rescaleX(xscale);
        update_images(transform);
        //imagegroup.attr("transform", transform);
        axis_transform = {'k': 1, 'x': transform.x, 'y': 50};
        gxaxis.call(xAxis.scale(transform.rescaleX(xscale)));
    }

    zoomIn = function() {
      svg.transition().call(zoom.scaleBy, 2);
    }
    zoomOut = function() {
      svg.transition().call(zoom.scaleBy, 0.5);
    }

//return svg.node();


</script>
